/**
 * Cecilia, an implementation of the Fractal component model in C.
 *
 * Copyright (C) 2007 ST Microelectronics, INRIA
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 *
 * Contact: fractal@objectweb.org
 *
 * Authors: Matthieu Leclercq, Lionel Debroux.
 */

// START SNIPPET: Content
#include <stdio.h>

/** Declare component internal data, empty here */
DECLARE_DATA {
} ;

/** Include cecilia.h. Must be included after the DECLARE_DATA */
#include <cecilia.h>

#include "FunctionArgTypes.h"


// -----------------------------------------------------------------------------
// Implementation of the Scheduler interface.
// -----------------------------------------------------------------------------
/**
 * This method is called by the request receiver.
 * Cecilia IDL declaration: void schedule(any task);
 */
void METHOD(s, schedule) (void *_this, void * task) {
#ifdef DEBUG
    fprintf(stdout,"SequentialScheduler: schedule\n");
#endif

    // Call function directly (synchronous).
    CALL(REQUIRED.rh, handleRequest, (void *)task);
}
